// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_FProperty.h"

#include "ISCW_UClass.h"
#include <memory>
#include <string>

using std::wstring;

namespace Sourcify
{	
	class ISCW_FInterfaceProperty : public virtual ISCW_FProperty
	{
	public:
		virtual ~ISCW_FInterfaceProperty() = default;

		virtual std::shared_ptr<ISCW_FInterfaceProperty> ToFInterfacePropertyPtr() = 0;
		virtual std::shared_ptr<const ISCW_FInterfaceProperty> ToFInterfacePropertyPtr() const = 0;

		virtual ISCW_UClassPtr GetInterfaceClass() const = 0;
	};

	using ISCW_FInterfacePropertyConstPtr = std::shared_ptr<const ISCW_FInterfaceProperty>;
	using ISCW_FInterfacePropertyPtr = std::shared_ptr<ISCW_FInterfaceProperty>;
} // namespace Sourcify